Gecode::Int::ReUnaryPropagator< View, pc, CtrlView > Class Template Reference

Reified unary propagator. More...

`#include <propagator.hpp>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low unary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| ReUnaryPropagator (Space &home, ReUnaryPropagator &p)
| Constructor for cloning p.
| ReUnaryPropagator (Space &home, Propagator &p, View x0, CtrlView b)
| Constructor for rewriting p during cloning.
| ReUnaryPropagator (Home home, View x0, CtrlView b)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

View | x0
| Single view.
CtrlView | b
| Boolean control view.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class View, PropCond pc, class CtrlView>
class Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >

Reified unary propagator.

Stores single view of type View with propagation condition pc and a Boolean control view of type CtrlView.

If the propagation condition pc has the value PC_GEN_NONE, no subscriptions are created for View.

Definition at line 54 of file propagator.hpp.

## Constructor & Destructor Documentation

## ReUnaryPropagator() [1/3]

template<class View, PropCond pc, class CtrlView>

Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::ReUnaryPropagator | ( | Space & | home,
|  | ReUnaryPropagator< View, pc, CtrlView > & | p )

protected

Constructor for cloning p.

## ReUnaryPropagator() [2/3]

template<class View, PropCond pc, class CtrlView>

Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::ReUnaryPropagator | ( | Space & | home,
|  | Propagator & | p,
|  | View | x0,
|  | CtrlView | b )

inline protected

Constructor for rewriting p during cloning.

Definition at line 173 of file propagator.hpp.

## ReUnaryPropagator() [3/3]

template<class View, PropCond pc, class CtrlView>

Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::ReUnaryPropagator | ( | Home | home,
|  | View | x0,
|  | CtrlView | b )

protected

Constructor for creation.

Definition at line 154 of file propagator.hpp.

## Member Function Documentation

## cost()

template<class View, PropCond pc, class CtrlView>

PropCost Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low unary).

Implements Gecode::Propagator.

Definition at line 182 of file propagator.hpp.

## reschedule()

template<class View, PropCond pc, class CtrlView>

void Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 188 of file propagator.hpp.

## dispose()

template<class View, PropCond pc, class CtrlView>

size_t Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Reimplemented in Gecode::Int::Dom::ReIntSet< View, rm >.

Definition at line 196 of file propagator.hpp.

## Member Data Documentation

## x0

template<class View, PropCond pc, class CtrlView>

View Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::x0

protected

Single view.

Definition at line 57 of file propagator.hpp.

## b

template<class View, PropCond pc, class CtrlView>

CtrlView Gecode::Int::ReUnaryPropagator< View, pc, CtrlView >::b

protected

Boolean control view.

Definition at line 59 of file propagator.hpp.

The documentation for this class was generated from the following file:

- gecode/int/propagator.hpp